package com.qmth.digit.print.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.digit.print.business.entity.BasicCardRule;
import com.qmth.digit.print.business.entity.BasicExamRule;
import com.qmth.digit.print.business.entity.BasicTemplateOrg;
import com.qmth.digit.print.business.entity.SysOrg;
import com.qmth.digit.print.business.mapper.BasicTemplateOrgMapper;
import com.qmth.digit.print.business.service.BasicTemplateOrgService;
import com.qmth.digit.print.common.enums.TemplateTypeEnum;
import org.springframework.stereotype.Service;

import java.awt.geom.QuadCurve2D;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 适用学院（题卡规则、模板适用学院） 服务实现类
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
@Service
public class BasicTemplateOrgServiceImpl extends ServiceImpl<BasicTemplateOrgMapper, BasicTemplateOrg> implements BasicTemplateOrgService {

    @Override
    public List<SysOrg> listByTypeAndTemplateId(String type, Long templateId) {
        return this.baseMapper.listByTypeAndTemplateId(type, templateId);
    }

    @Override
    public void removeByRuleId(Long id) {
        UpdateWrapper<BasicTemplateOrg> updateWrapper = new UpdateWrapper<>();
        updateWrapper.lambda().eq(BasicTemplateOrg::getRuleId, id);
        this.remove(updateWrapper);
    }

    @Override
    public void saveBatch(Long ruleId, Long[] orgIds, Long createId) {
        List<BasicTemplateOrg> list = new ArrayList<>();
        for (Long orgId : orgIds) {
            BasicTemplateOrg basicTemplateOrg = new BasicTemplateOrg();
            basicTemplateOrg.setType(TemplateTypeEnum.CARD_RULE);
            basicTemplateOrg.setRuleId(ruleId);
            basicTemplateOrg.setOrgId(orgId);
            basicTemplateOrg.setCreateId(createId);
            basicTemplateOrg.setCreateTime(System.currentTimeMillis());
            list.add(basicTemplateOrg);
        }
        this.saveBatch(list);
    }
}
